<?php
declare(strict_types=1);

use Phinx\Migration\AbstractMigration;

final class AddQueueTable extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        // Create table for Queue objects
        $table = $this->table('queues');
        $table->addColumn('title', 'string', ['null' => false])
            ->addColumn('description', 'text', ['null' => false])
            ->addTimestamps()
            ->addIndex(['title'])
            ->create();

        // Update tickets table to have a Queue ID field
        $tickets = $this->table('tickets')
            ->addColumn('queue_id', 'integer', ['null' => false])
            ->addForeignKey('queue_id', 'queues', 'id', ['delete' => 'CASCADE', 'update' => 'CASCADE'])
            ->update();
    }
}
